<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 23B.40</title>

    <!--ad bootrap here-->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">


</head>
<body>
    <div class="container-fluid" >
        <div class="row" style="background-image: url('LuckyDiceImages/cover.jpg'); min-height: 50px;"></div>
        <div class="container border" >

           <div class="row">
                <div class="col-5 border">
                    <div class="row form-group">
                        <h1 style="font-size: larger;">Nhập thông tin của bạn</h1>
                    </div>
                    <div class="row form-group">
                        <div class="col-4" >
                            <label >Username: </label>
                        </div>
                        <div class="col-8">
                            <input id="inp-username" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-4" >
                            <label>Firstname: </label>
                        </div>
                        <div class="col-8">
                            <input id="inp-firstname" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-4" >
                            <label>Lastname: </label>
                        </div>
                        <div class="col-8">
                            <input id="inp-lastname" class="form-control">
                        </div> 
                    </div>
                </div>
                <div class="col-4 border">
                    <div class="row form-group ">
                        <div class="col-12 text-center">
                            <button onclick="onBtnNemXuatXac()" class="btn btn-primary">ném xúc xắc</button>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-12 text-center">
                            <img id="img-dice" src="LuckyDiceImages/dice.png" width="60%">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-12 text-center">
                            <p style="color: red;"> chúc mừng bạn đã nhận được phần quà hấp dẫn</p>>
                        </div>
                    </div>
                </div>
                <div class="col-3 border">
                    <div class="row">
                        <div class="col-12">
                            <p id="p-voucher">voucher: </p>
                            <p id="p-id" >ID: </p>
                            <p id="p-phantramgiamgia">phần trăm giảm giá: </p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12 text-center">
                            <img src="LuckyDiceImages/xe-may.jpg" width="90%" >
                        </div>
                    </div>
                </div>
           </div>

           <div class="row text-center">
                <div class="col-12 border text-center">
                    <button onclick="onBtnHistoryDice()" class="col-3 btn btn-info">Dice history</button>
                    <button onclick="onBtnHistoryVoucher()"  class="col-3 btn btn-primary" >voucher history</button>
                    <button onclick="onBtnHistoryPresent()" class="col-3 btn btn-warning" >present history</button>
                </div>
           </div>

           <div class="row">
                <table id="table-dice-history" class="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                          <th>Game time play</th>
                          <th>Dice</th>
                        </tr>
                      </thead>
                      <tbody>
                        
                      </tbody>
                </table>
           </div>

        </div>
    </div>
    
</body>

<script>

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATON_HEADER = "application/json;charset=UTF-8";
 

    var gUser = {
            username: "",
            firstname: "",
            lastname: ""
        }


    function onBtnNemXuatXac(){

        var vUsername = document.getElementById("inp-username").value.trim();
        var vFirstname = document.getElementById("inp-firstname").value.trim();
        var vLastname = document.getElementById("inp-lastname").value.trim();
        
        var vNewUser = getNewUser(vUsername,vFirstname,vLastname);
        if(!validateUser(vNewUser)){
            return;
        }
        var vXmlHttpDice = new XMLHttpRequest();
        
        goijAPItungXucXac(vNewUser,vXmlHttpDice);
        vXmlHttpDice.onreadystatechange = function () {
            // Khi request đã xử lý xong và thành công!
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                // hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                //b4 hiển thị thông tin tung xúc xắc ra web
                //hiển thị JSON ra console
                console.log(vXmlHttpDice.responseText);
                var vRespone = JSON.parse(vXmlHttpDice.responseText);
                console.log(vRespone);
                console.log(vRespone.dice);
                hienThiDice(vRespone);
            }
        }
    }

    function onBtnHistoryDice(){
        var vUsername = document.getElementById("inp-username").value.trim();
        var vFirstname = document.getElementById("inp-firstname").value.trim();
        var vLastname = document.getElementById("inp-lastname").value.trim();
        
        var vNewUser = getNewUser(vUsername,vFirstname,vLastname);
        if(!validateUser(vNewUser)){
            return;
        }
        debugger;
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        goiApiDeLayDideHistory(vNewUser,vXmlHttpDiceHistory);
        vXmlHttpDiceHistory.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            // B4: hiển thị lịch sử lên table
            hienThiLichSuLenTable(vXmlHttpDiceHistory);
          }
        }

    }

    function onBtnHistoryVoucher(){
        //b1,2 thu thập dữ liệu và kiểm tra  
        var vUsername = document.getElementById("inp-username").value.trim();
        var vFirstname = document.getElementById("inp-firstname").value.trim();
        var vLastname = document.getElementById("inp-lastname").value.trim();
        
        var vNewUser = getNewUser(vUsername,vFirstname,vLastname);
        if(!validateUser(vNewUser)){
            return;
        }

          const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
       // var vUserNameTest = "ngado20";
        var vXmlHttpVoucherHistory = new XMLHttpRequest();
        vXmlHttpVoucherHistory.open("GET", vBASE_URL + "/voucher-history?username=" + vNewUser.username, true);
        vXmlHttpVoucherHistory.send();
        vXmlHttpVoucherHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vVoucherHistory = vXmlHttpVoucherHistory.responseText;
                    console.log(vVoucherHistory);
                    var vArrayVoucher = JSON.parse(vVoucherHistory);
                    console.log(vArrayVoucher);
                    debugger;
                    hienThiLichSuVoucherLenTable(vArrayVoucher);
                }
            }
    }

    function onBtnHistoryPresent(){
        var vUsername = document.getElementById("inp-username").value.trim();
        var vFirstname = document.getElementById("inp-firstname").value.trim();
        var vLastname = document.getElementById("inp-lastname").value.trim();
        
        var vNewUser = getNewUser(vUsername,vFirstname,vLastname);
        if(!validateUser(vNewUser)){
            return;
        }

        const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
       // var vUserNameTest = "ngado20";
        // create a request
        var vXmlHtt0pPrizeHistory = new XMLHttpRequest();
        vXmlHtt0pPrizeHistory.open("GET", vBASE_URL + "/prize-history?username=" + vNewUser.username, true);
        vXmlHtt0pPrizeHistory.send();
        vXmlHtt0pPrizeHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vPrizeHistory = vXmlHtt0pPrizeHistory.responseText;
                    console.log(vPrizeHistory);
                    hienThiLichSuPresentLenTable(vXmlHtt0pPrizeHistory);
                }
            }
    }

    function getNewUser(paraUser,paraFirstname,paraLastname){
        var newUser = {
            username: paraUser,
            firstname: paraFirstname,
            lastname: paraLastname
        };
        return newUser;
    }
    function validateUser(paraUser){
        if(paraUser.username == "" || paraUser.firstname == ""
        || paraUser.lastname == ""){
            alert("thông tin điền vào chưa hợp lệ");
            return false;
        }
        return true;
    }

    function goijAPItungXucXac(paraUserObj,paraXMlHttp){

    var vPersonJsonData = JSON.stringify(paraUserObj);
    paraXMlHttp.open("POST", gBASE_URL + "/dice", true);
    paraXMlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATON_HEADER);
    paraXMlHttp.send(vPersonJsonData);
    }

    function hienThiDice(paraObjectDice){
        var vDice = document.getElementById("img-dice");
        
        switch(paraObjectDice.dice){
            case 1: vDice.src = "LuckyDiceImages/1.png"; break;
            case 2: vDice.src = "LuckyDiceImages/2.png"; break;
            case 3: vDice.src = "LuckyDiceImages/3.png"; break;
            case 4: vDice.src = "LuckyDiceImages/4.png"; break;
            case 5: vDice.src = "LuckyDiceImages/5.png"; break;
            case 6: vDice.src = "LuckyDiceImages/6.png"; break;

        }
        var vVoucher = document.getElementById("p-voucher");
        var vId = document.getElementById("p-id");
        var vPhanTramGiamGia = document.getElementById("p-phantramgiamgia");

        if(paraObjectDice.voucher != null){
            vVoucher.innerHTML ="Voucher: "+ paraObjectDice.voucher.maVoucher;
            vId.innerHTML ="ID: " + paraObjectDice.voucher.id;
            vPhanTramGiamGia.innerHTML ="phần trăm giản giá: " + paraObjectDice.voucher.phanTramGiamGia + "%";
        
        }else{
            vVoucher.innerHTML ="Voucher:" ;
            vId.innerHTML ="ID: " ;
            vPhanTramGiamGia.innerHTML ="phần trăm giản giá: %";
        
        }

        

    }

    function goiApiDeLayDideHistory(paramUserObj, paramXmlHttpObj) {
      paramXmlHttpObj.open("GET", gBASE_URL + "/dice-history?username=" + paramUserObj.username, true);
      paramXmlHttpObj.send();
    }

    function hienThiLichSuLenTable(paramXmlHttpObj) {
      console.log(paramXmlHttpObj.responseText);
      var vDiceHistoryObj = JSON.parse(paramXmlHttpObj.responseText);

      var vDiceHistoryTable = document.getElementById("table-dice-history");
      var vTheadDice = vDiceHistoryTable.getElementsByTagName("thead")[0];
      var vTbodyDiceHistory = vDiceHistoryTable.getElementsByTagName("tbody")[0];
      //xóa trắng dữ liệu trong Thead
      vTheadDice.innerHTML = "";
      var vNewRowHead = vTheadDice.insertRow(-1);
      var vHeadGameCell = vNewRowHead.insertCell(0);
      var vHeadDiceCell = vNewRowHead.insertCell(1);

      vHeadGameCell.innerHTML = "Game";
      vHeadDiceCell.innerHTML = "Dice";
      
      // xóa trắng dữ liệu trong bảng đã
      vTbodyDiceHistory.innerHTML = "";
      
      for(var bI = 0; bI < vDiceHistoryObj.dices.length; bI ++) {
        //var bNewRow = vTbodyDiceHistory.insertRow(gEND_OF_ROW_COL);
        var bNewRow = vTbodyDiceHistory.insertRow(-1);
        var bGameCell = bNewRow.insertCell(0);
        var bDiceCell = bNewRow.insertCell(1);

        bGameCell.innerHTML = bI + 1;
        bDiceCell.innerHTML = vDiceHistoryObj.dices[bI];
      }
    }

    function hienThiLichSuVoucherLenTable(paraArrayVoucher){
      var vVouicherHistoryTable = document.getElementById("table-dice-history");
      var vTbodyVoucherHistory =  vVouicherHistoryTable.getElementsByTagName("tbody")[0];
      var vTHeadVoucherHistory =  vVouicherHistoryTable.getElementsByTagName("thead")[0];
      //xóa dữ liệu table cũ
      vTHeadVoucherHistory.innerHTML = "";
      //thay đổi các dòng trong thead
      
        var vNewHeadRow = vTHeadVoucherHistory.insertRow(-1);
        var vSoThuTuCell = vNewHeadRow.insertCell(0);
        var vMaVoucherCell = vNewHeadRow.insertCell(1);
        var vPhanTramGiamGiaCell = vNewHeadRow.insertCell(2);

        vSoThuTuCell.innerHTML = "Voucher history time ";
        vMaVoucherCell.innerHTML = "ID voucher";

        vPhanTramGiamGiaCell.innerHTML = "Discount ";
        //thay đổi các dòng trong body
        debugger;
        vTbodyVoucherHistory.innerHTML = "";

        for(var i =0; i<paraArrayVoucher.vouchers.length; i++){
            var bNewRowTbody = vTbodyVoucherHistory.insertRow(-1);
            var bSoThuTu = bNewRowTbody.insertCell(0);
            var bMaVoucherCell = bNewRowTbody.insertCell(1);
            var bPhanTramGiamGiaCell = bNewRowTbody.insertCell(2);

            bSoThuTu.innerHTML = i+ 1 ;
            bMaVoucherCell.innerHTML = paraArrayVoucher.vouchers[i].maVoucher;
            bPhanTramGiamGiaCell.innerHTML = paraArrayVoucher.vouchers[i].phanTramGiamGia + " %";
        }

        

    }

    function hienThiLichSuPresentLenTable(paramXmlHttpObj) {
      console.log(paramXmlHttpObj.responseText);
      var vDiceHistoryObj = JSON.parse(paramXmlHttpObj.responseText);

      var vDiceHistoryTable = document.getElementById("table-dice-history");
      var vTheadDice = vDiceHistoryTable.getElementsByTagName("thead")[0];
      var vTbodyDiceHistory = vDiceHistoryTable.getElementsByTagName("tbody")[0];
      //xóa trắng dữ liệu trong Thead
      vTheadDice.innerHTML = "";
      var vNewRowHead = vTheadDice.insertRow(-1);
      var vHeadGameCell = vNewRowHead.insertCell(0);
      var vHeadDiceCell = vNewRowHead.insertCell(1);

      vHeadGameCell.innerHTML = "Time";
      vHeadDiceCell.innerHTML = "Present";
      
      // xóa trắng dữ liệu trong bảng đã
      vTbodyDiceHistory.innerHTML = "";
      
      for(var bI = 0; bI < vDiceHistoryObj.prizes.length; bI ++) {
        //var bNewRow = vTbodyDiceHistory.insertRow(gEND_OF_ROW_COL);
        var bNewRow = vTbodyDiceHistory.insertRow(-1);
        var bGameCell = bNewRow.insertCell(0);
        var bDiceCell = bNewRow.insertCell(1);

        bGameCell.innerHTML = bI + 1;
        bDiceCell.innerHTML = vDiceHistoryObj.prizes[bI];
      }
    }
</script>

</html>